std::reverse_iterator< _Iterator >(3)

NAME
std::reverse_iterator< _Iterator > -

SYNOPSIS

Inherits std::iterator< iterator_traits< _Iterator >::iterator_category, iterator_traits< _Iterator >::value_type, iterator_traits< _Iterator >::difference_type, iterator_traits< _Iterator >::pointer, iterator_traits< _Iterator >::reference >.

  Public Types
typedef
__traits_type::difference_type difference_type"
typedef iterator_traits
< _Iterator >
::iterator_category iterator_category"
typedef _Iterator iterator_type
typedef __traits_type::pointer pointer
typedef __traits_type::reference reference
typedef iterator_traits
< _Iterator >::value_type value_type"

  Public Member Functions
reverse_iterator ()
reverse_iterator (iterator_type __x)
reverse_iterator (const reverse_iterator &__x)
template<typename _Iter > reverse_iterator (const reverse_iterator< _Iter > &__x)
iterator_type base () const
reference operator* () const
reverse_iterator operator+ (difference_type __n) const
reverse_iterator & operator++ ()
reverse_iterator operator++ (int)
reverse_iterator & operator+= (difference_type __n)
reverse_iterator operator- (difference_type __n) const
reverse_iterator & operator-- ()
reverse_iterator operator-- (int)
reverse_iterator & operator-= (difference_type __n)
pointer operator-> () const
reference operator[] (difference_type __n) const

  Protected Types
typedef iterator_traits
< _Iterator > __traits_type"

  Protected Attributes
_Iterator current

Detailed Description

  template<typename _Iterator>class std::reverse_iterator< _Iterator >
Bidirectional and random access iterators have corresponding reverse iterator adaptors that iterate through the data structure in the opposite direction. They have the same signatures as the corresponding iterators. The fundamental relation between a reverse iterator and its corresponding iterator i is established by the identity:

*      &*(reverse_iterator(i)) == &*(i - 1)
*

This mapping is dictated by the fact that while there is always a pointer past the end of an array, there might not be a valid pointer before the beginning of an array. [24.4.1]/1,2

Reverse iterators can be tricky and surprising at first. Their semantics make sense, however, and the trickiness is a side effect of the requirement that the iterators must be safe.

Definition at line 96 of file stl_iterator.h.

Member Typedef Documentation

  typedef iterator_traits< _Iterator >::iterator_category std::iterator< iterator_traits< _Iterator >::iterator_category , iterator_traits< _Iterator >::value_type , iterator_traits< _Iterator >::difference_type , iterator_traits< _Iterator >::pointer , iterator_traits< _Iterator >::reference >::iterator_category [inherited]

One of the tag types.

Definition at line 121 of file stl_iterator_base_types.h.

  typedef iterator_traits< _Iterator >::value_type std::iterator< iterator_traits< _Iterator >::iterator_category , iterator_traits< _Iterator >::value_type , iterator_traits< _Iterator >::difference_type , iterator_traits< _Iterator >::pointer , iterator_traits< _Iterator >::reference >::value_type [inherited]

The type 'pointed to' by the iterator.

Definition at line 123 of file stl_iterator_base_types.h.

Constructor & Destructor Documentation

  template<typename _Iterator> std::reverse_iterator< _Iterator >::reverse_iterator () [inline]
The default constructor value-initializes member current. If it is a pointer, that means it is zero-initialized.

Definition at line 120 of file stl_iterator.h.

Referenced by std::reverse_iterator< _Iterator >::operator+(), and std::reverse_iterator< _Iterator >::operator-().

  template<typename _Iterator> std::reverse_iterator< _Iterator >::reverse_iterator (iterator_type__x) [inline], [explicit]
This iterator will move in the opposite direction that x does.

Definition at line 126 of file stl_iterator.h.

  template<typename _Iterator> std::reverse_iterator< _Iterator >::reverse_iterator (const reverse_iterator< _Iterator > &__x) [inline]
The copy constructor is normal.

Definition at line 131 of file stl_iterator.h.

  template<typename _Iterator> template<typename _Iter > std::reverse_iterator< _Iterator >::reverse_iterator (const reverse_iterator< _Iter > &__x) [inline]
A reverse_iterator across other types can be copied if the underlying iterator can be converted to the type of current.

Definition at line 139 of file stl_iterator.h.

Member Function Documentation

  template<typename _Iterator> iterator_type std::reverse_iterator< _Iterator >::base () const [inline]

Returns:
    current, the iterator used for underlying work.

Definition at line 146 of file stl_iterator.h.

Referenced by std::operator==().

  template<typename _Iterator> reference std::reverse_iterator< _Iterator >::operator* () const [inline]

Returns:
    A reference to the value at --current

This requires that --current is dereferenceable.

Warning:
    This implementation requires that for an iterator of the underlying iterator type, x, a reference obtained by *x remains valid after x has been modified or destroyed. This is a bug: http://gcc.gnu.org/PR51823

Definition at line 160 of file stl_iterator.h.

Referenced by std::reverse_iterator< _Iterator >::operator->().

  template<typename _Iterator> reverse_iterator std::reverse_iterator< _Iterator >::operator+ (difference_type__n) const [inline]

Returns:
    A reverse_iterator that refers to current - __n

The underlying iterator must be a Random Access Iterator.

Definition at line 231 of file stl_iterator.h.

References std::reverse_iterator< _Iterator >::reverse_iterator().

  template<typename _Iterator> reverse_iterator& std::reverse_iterator< _Iterator >::operator++ () [inline]

Returns:
    *this

Decrements the underlying iterator.

Definition at line 181 of file stl_iterator.h.

  template<typename _Iterator> reverse_iterator std::reverse_iterator< _Iterator >::operator++ (int) [inline]

Returns:
    The original value of *this

Decrements the underlying iterator.

Definition at line 193 of file stl_iterator.h.

  template<typename _Iterator> reverse_iterator& std::reverse_iterator< _Iterator >::operator+= (difference_type__n) [inline]

Returns:
    *this

Moves the underlying iterator backwards __n steps. The underlying iterator must be a Random Access Iterator.

Definition at line 241 of file stl_iterator.h.

  template<typename _Iterator> reverse_iterator std::reverse_iterator< _Iterator >::operator- (difference_type__n) const [inline]

Returns:
    A reverse_iterator that refers to current - __n

The underlying iterator must be a Random Access Iterator.

Definition at line 253 of file stl_iterator.h.

References std::reverse_iterator< _Iterator >::reverse_iterator().

  template<typename _Iterator> reverse_iterator& std::reverse_iterator< _Iterator >::operator-- () [inline]

Returns:
    *this

Increments the underlying iterator.

Definition at line 206 of file stl_iterator.h.

  template<typename _Iterator> reverse_iterator std::reverse_iterator< _Iterator >::operator-- (int) [inline]

Returns:
    A reverse_iterator with the previous value of *this

Increments the underlying iterator.

Definition at line 218 of file stl_iterator.h.

  template<typename _Iterator> reverse_iterator& std::reverse_iterator< _Iterator >::operator-= (difference_type__n) [inline]

Returns:
    *this

Moves the underlying iterator forwards __n steps. The underlying iterator must be a Random Access Iterator.

Definition at line 263 of file stl_iterator.h.

  template<typename _Iterator> pointer std::reverse_iterator< _Iterator >::operator-> () const [inline]

Returns:
    A pointer to the value at --current

This requires that --current is dereferenceable.

Definition at line 172 of file stl_iterator.h.

References std::reverse_iterator< _Iterator >::operator*().

  template<typename _Iterator> reference std::reverse_iterator< _Iterator >::operator[] (difference_type__n) const [inline]

Returns:
    The value at current - __n - 1

The underlying iterator must be a Random Access Iterator.

Definition at line 275 of file stl_iterator.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.